SystemOrganization addCategory: #'AL-HtmlApp-Core'!

ALInputTag subclass: #ALAppInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppInputTag methodsFor: 'accessing' stamp: 'cwp 9/20/2011 11:39'!
callback: aValuable
	self name: (canvas currentForm registerCallback: aValuable) asString
! !

!ALAppInputTag methodsFor: 'accessing' stamp: 'cwp 7/10/2012 14:04'!
send: aSelector to: anObject
	self value: (anObject perform: aSelector).
	self callback: [:v | anObject perform: aSelector asMutator with: v]! !

Object subclass: #ALForm
	instanceVariableNames: 'callbacks default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALForm methodsFor: 'processing' stamp: 'cwp 7/10/2012 14:17'!
appyData: data
	data do: 
		[ :ea || index |
		index := ea key asNumber.
		(callbacks at: index) cull: ea value]! !

!ALForm methodsFor: 'initialize-release' stamp: 'cwp 7/10/2012 15:05'!
initialize
	callbacks := #().
	default := nil! !

!ALForm methodsFor: 'processing' stamp: 'cwp 7/10/2012 15:08'!
process
	| answer |
	answer := default value.
	^ (answer isKindOf: ALResource) ifTrue: [answer]! !

!ALForm methodsFor: 'rendering' stamp: 'cwp 7/10/2012 15:05'!
registerCallback: aValuable
	callbacks := callbacks copyWith: aValuable asCallback.
	^ callbacks size.! !

!ALForm methodsFor: 'rendering' stamp: 'cwp 7/10/2012 15:05'!
registerDefaultCallback: aValuable
	default := aValuable asCallback! !

ALATag subclass: #ALAppATag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppATag methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 11:40'!
callback: aValuable
	| path |
	path := canvas context registerCallback: aValuable.
	self href: path asString
! !

!ALAppATag methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 23:04'!
linkTo: aResource
	| path |
	path := canvas context registerResource: aResource.
	self href: path asString
	
! !

!ALAppATag methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 11:41'!
navigate: aValuable
	| path |
	path := canvas context registerNavigation: aValuable.
	self href: path asString
	
! !

ALHtml5Canvas subclass: #ALAppHtml5Canvas
	instanceVariableNames: 'context form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppHtml5Canvas class methodsFor: 'instance creation' stamp: 'cwp 9/19/2011 17:10'!
context: aContext stream: aWriteStream
	^ self basicNew
		initializeWithContext: aContext stream: aWriteStream! !

!ALAppHtml5Canvas methodsFor: 'tags' stamp: 'cwp 9/20/2011 11:21'!
a
	^ self open: (ALAppATag on: self)! !

!ALAppHtml5Canvas methodsFor: 'accessing' stamp: 'cwp 9/19/2011 17:14'!
context
	^ context! !

!ALAppHtml5Canvas methodsFor: 'accessing' stamp: 'cwp 9/20/2011 10:31'!
currentForm
	^ form! !

!ALAppHtml5Canvas methodsFor: 'tags' stamp: 'cwp 9/19/2011 21:39'!
form
	^ self open: (ALAppFormTag on: self)! !

!ALAppHtml5Canvas methodsFor: 'initialize-release' stamp: 'cwp 9/19/2011 17:11'!
initializeWithContext: aContext stream: aWriteStream 
	self initializeWithStream: aWriteStream.
	context := aContext! !

!ALAppHtml5Canvas methodsFor: 'tags' stamp: 'cwp 9/20/2011 00:49'!
input
	^ self open: (ALAppInputTag on: self)! !

!ALAppHtml5Canvas methodsFor: 'forms' stamp: 'cwp 9/13/2012 12:49'!
useForm: aForm during: aBlock
	| tCurrent tStack tEscaping tStream |
	
	^	[tCurrent := current.
		tStack := stack.
		tStream := stream.
		tEscaping := escaping.
		current := nil.
		stack := OrderedCollection new.
		stream := (String new: 64) writing.
		self initializeEscaping.
		form := aForm.
		aBlock value.
		self flush.
		stream conclusion] ensure:
			[current := tCurrent.
			stack := tStack.
			stream := tStream.
			escaping := tEscaping.
			form := nil].
	
			! !

ALFormTag subclass: #ALAppFormTag
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2011 14:34'!
beGet
	self method: 'GET'! !

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2011 14:33'!
bePost
	self method: 'POST'! !

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 7/10/2012 15:17'!
callback: aValuable
	form registerDefaultCallback: aValuable.
	! !

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 7/10/2012 15:17'!
initialize
	super initialize.
	form := ALForm new.! !

!ALAppFormTag methodsFor: 'as yet unclassified' stamp: 'cwp 7/10/2012 15:17'!
with: anObject
	| html path |
	html := canvas useForm: form during: [ canvas render: anObject ].
	path := canvas context registerForm: form.
	self action: path asString.
	super with: [ canvas raw: html ]! !

ALResource subclass: #ALFormResource
	instanceVariableNames: 'resource form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALFormResource class methodsFor: 'as yet unclassified' stamp: 'cwp 9/20/2011 00:29'!
resource: aResource form: aForm
	^ self basicNew
		initializeWithResource: aResource form: aForm ! !

!ALFormResource methodsFor: 'private' stamp: 'cwp 7/10/2012 15:07'!
applyRequest: aRequest
	| data |
	data := aRequest readEntityWith: 
		[ :in | ALFormDataParser parse: (in encoding: #ascii) ].
	form appyData: data.
	^ form process ifNil: [resource]! !

!ALFormResource methodsFor: 'private' stamp: 'cwp 10/8/2012 00:19'!
handle: aRequest locator: aLocator
	| path |
	path := aLocator urlForResource: (self applyRequest: aRequest).
	^ ALResponse seeOther: path! !

!ALFormResource methodsFor: 'public' stamp: 'cwp 10/1/2011 16:29'!
handleGet: aRequest locator: aLocator
	^ self handle: aRequest locator: aLocator! !

!ALFormResource methodsFor: 'public' stamp: 'cwp 10/1/2011 16:29'!
handlePost: aRequest locator: aLocator
	^ self handle: aRequest locator: aLocator! !

!ALFormResource methodsFor: 'initialization' stamp: 'cwp 9/20/2011 00:28'!
initializeWithResource: aResource form: aForm
	self initialize.
	resource := aResource.
	form := aForm.! !

ALResource subclass: #ALHtmlResource
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-HtmlApp-Core'!

!ALHtmlResource class methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 17:00'!
component: aComponent
	^ self basicNew initializeWithContent: aComponent! !

!ALHtmlResource class methodsFor: 'as yet unclassified' stamp: 'cwp 9/27/2011 17:00'!
content: aComponent
	^ self basicNew initializeWithContent: aComponent! !

!ALHtmlResource methodsFor: 'private' stamp: 'cwp 4/3/2012 17:25'!
handleGet: aRequest locator: aLocator
	^ ALResponse 
		type: ALContentType html 
		callback: [ :out | self renderOnStream: out locator: aLocator ]! !

!ALHtmlResource methodsFor: 'initialization' stamp: 'cwp 9/27/2011 17:00'!
initializeWithContent: anObject
	content := anObject  ! !

!ALHtmlResource methodsFor: 'private' stamp: 'cwp 4/3/2012 17:25'!
renderOnStream: out locator: aLocator
	| utf8 context |
	utf8 := out encoding: #utf8.
	context := ALRenderingContext resource: self locator: aLocator.
	^ content renderOn: (ALAppHtml5Canvas context: context stream: utf8)! !
